/*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA02111-1307USA
*
* hwatchdog
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "../linux/include/linux/gpio_dev.h"
#include "../linux/include/linux/ioctl.h"

#define GPO	3
#define MCTL	4 
#define DEBUG  0

void print_usage() {
	printf("hwatchdog heartbeat|status|enable|disable\n");
	exit(0);
}

int main(int argc, char **argv) {
	int fd,t_result,delay;
	int result = 0;
	int old_result = 2;
	
	if (argc!=2) print_usage();
	
	fd = open("/dev/gpio", O_RDWR);
	while (fd<0) {
		if (DEBUG) printf("device busy\n");
		srand(time(NULL));
		delay = 1 + (int)(10 * (rand()/(RAND_MAX+1.0)));
		sleep(delay);		
		
		fd = open("/dev/gpio", O_RDWR);
	}
			
	if (!strcmp(argv[1],"heartbeat")) {
		ioctl(fd, GPIO_CLEAR, GPO);
		t_result = usleep( 999999 );		
		ioctl(fd, GPIO_SET, GPO);
		close(fd);	
	} else if (!strcmp(argv[1], "status")) 
	{
		result = ioctl(fd, GPIO_GET, GPO);
		printf("GPO is %s\n", (result ? "HIGH" : "LOW"));
		result = ioctl(fd, GPIO_GET, MCTL);
		printf("MCTL is %s\n", (result ? "HIGH" : "LOW"));		
	} else if (!strcmp(argv[1], "enable"))
	// set MCTL to normal mode
	{
		ioctl(fd, GPIO_SET, MCTL);
		ioctl(fd, GPIO_SET, GPO);
	} else if (!strcmp(argv[1], "disable"))
	{
		ioctl(fd, GPIO_CLEAR, GPO);
	} else print_usage();

	return result;
}
